/*
{
answer:"special",
triggers:{zone-scene:[{group:1,scene:1,name:[{de_DE:'dingsa'}]},{group:0,scene:2},{zone:0,scene:3}],
          device:[{id:0,name:[{de_DE:'dingsa'}]}], // device click events
          sensor-event:[{id:'.0',value:'inactive',name:[{de_DE:'dingsa'}]}],  // akm event
          device-event:[{id:'eventXY',name:[{de_DE:'dingsa'}]}]}, // sensor event
actions:{ zone-action:[{scene:1,group:1,name:[{de_DE:'dingsa'}]},{group:0,scene:2},{zone:0,scene:3}]
          device-action:[{scene:1,name:[{de_DE:'dingsa'}]},
                         {outputValue:1,name:[{de_DE:'dingsa'}]}]
},
conditions:{
	   sensor-event:[{}]}
}*/

var lWarn = {
	logln : function(o) {
	}
};
var lInfo = {
	logln : function(o) {
	}
};

var LOGFILE_NAME = "sr-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME)

Property.setSavedProperty = function(path, value) {
	Property.setProperty(path, value);
	Property.setFlag(path, 'ARCHIVE', true);
}

var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};



try {
	if (raisedEvent.name=='system-addon-scene-responder.registerSpecialDSIDDevices') {
		lInfo.logln('system-addon-scene-responder.registerSpecialDSIDDevices');
		for (var sKey in raisedEvent.parameter) {
			lInfo.logln('type ' + sKey + ' : ' + raisedEvent.parameter[sKey]);
		}
		if (raisedEvent.parameter._context!=null)
			if (raisedEvent.parameter.values!=null) {
				lInfo.logln('context ' + raisedEvent.parameter._context);
				lInfo.logln('values ' + raisedEvent.parameter.values);
				var context=raisedEvent.parameter._context;
				lInfo.logln('removing context ' + context);
				if (Property.getNode('specialDSIDAction')!=null) {
					var oArray=Property.getNode('specialDSIDAction').getChildren();
					for (var iIndex=0;iIndex<oArray.length;iIndex++) {
						if (oArray[iIndex].getChild('context').getValue()==context)
							Property.getNode('specialDSIDAction').removeChild(oArray[iIndex].getName());
					}
				}
				var oArray=JSON.parse(raisedEvent.parameter.values);
				for (var jIndex=0;jIndex<oArray.length;jIndex++) {
					lInfo.logln('adding  ' + jIndex + ' from ' +oArray.length);
					var basePath='specialDSIDAction/' + oArray[jIndex].dsid;
					Property.getNode('specialDSIDAction').removeChild(oArray[jIndex].dsid)
					Property.setSavedProperty(basePath+'/context',context);

					var DataObject=oArray[jIndex];
					if (DataObject.actions != null) {
						if (DataObject.actions['zone-action'] != null) {
							for (var iIndex = 0; iIndex < DataObject.actions['zone-action'].length; iIndex++) {
								var oDataObject = DataObject.actions['zone-action'][iIndex];
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty(basePath + '/actions/zoneAction/' + iIndex + '/name/' + sKey, Utf8.encode(oDataObject.name[sKey]));
								}

								Property.setSavedProperty(basePath + '/actions/zoneAction/' + iIndex + '/scene', oDataObject.scene);
								if (oDataObject.zone != null)
									Property.setSavedProperty(basePath + '/actions/zoneAction/' + iIndex + '/zone', oDataObject.zone);
								if (oDataObject.group != null)
									Property.setSavedProperty(basePath + '/actions/zoneAction/' + iIndex + '/group', oDataObject.group);
							}
						}
						if (DataObject.actions['device-action'] != null) {
							for (var iIndex = 0; iIndex < DataObject.actions['device-action'].length; iIndex++) {
								var oDataObject = DataObject.actions['device-action'][iIndex];
								lInfo.logln('action ' + JSON.stringify(oDataObject));
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty(basePath + '/actions/deviceActions/' + iIndex + '/name/' + sKey, Utf8.encode(oDataObject.name[sKey]));
								}
								if (oDataObject.scene != null)
									Property.setSavedProperty(basePath + '/actions/deviceActions/' + iIndex + '/scene', oDataObject.scene);
								if (oDataObject.outputValue != null)
									Property.setSavedProperty(basePath + '/actions/deviceActions/' + iIndex + '/outputValue', oDataObject.outputValue);
							}
						}
					}
					if (DataObject.triggers != null) {
						if (DataObject.triggers['zone-scene'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['zone-scene'].length; iIndex++) {
								var oDataObject = DataObject.triggers['zone-scene'][iIndex];
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty(basePath + '/triggers/zoneSzene/' + iIndex + '/name/' + sKey, Utf8.encode(oDataObject.name[sKey]));
								}
								Property.setSavedProperty(basePath + '/triggers/zoneSzene/' + iIndex + '/scene', oDataObject.scene);
								if (oDataObject.zone != null)
									Property.setSavedProperty(basePath + '/triggers/zoneSzene/' + iIndex + '/zone', oDataObject.zone);
								if (oDataObject.group != null)
									Property.setSavedProperty(basePath + '/triggers/zoneSzene/' + iIndex + '/group', oDataObject.group);
							}
						}
						if (DataObject.triggers['device'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['device'].length; iIndex++) {
								var oDataObject = DataObject.triggers['device'][iIndex];
								Property.setSavedProperty(basePath + '/triggers/deviceMsg/' + iIndex + '/id', oDataObject.id);
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty(basePath + '/triggers/deviceMsg/' + iIndex + '/name/' + sKey, Utf8.encode(oDataObject.name[sKey]));
								}
							}
						}
						if (DataObject.triggers['sensor-event'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['sensor-event'].length; iIndex++) {
								var oDataObject = DataObject.triggers['sensor-event'][iIndex];
								Property.setSavedProperty(basePath + '/triggers/sensorEvent/' + iIndex + '/id', oDataObject.id);
								Property.setSavedProperty(basePath + '/triggers/sensorEvent/' + iIndex + '/value', oDataObject.value);
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty(basePath + '/triggers/sensorEvent/' + iIndex + '/name/' + sKey, Utf8.encode(oDataObject.name[sKey]));
								}
							}
						}
						if (DataObject.triggers['device-event'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['device-event'].length; iIndex++) {
								var oDataObject = DataObject.triggers['device-event'][iIndex];
								Property.setSavedProperty(basePath + '/triggers/deviceEvents/' + iIndex + '/id', oDataObject.id);
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty(basePath + '/triggers/deviceEvents/' + iIndex + '/name/' + sKey, Utf8.encode(oDataObject.name[sKey]));
								}
							}
						}
					}

				
				}
			}
		/*parameter: context: <app>
		 *           values: [{
		 *           dsid: <id>
		 *           actions: []
		 *           triggers: []
		 *           }]*/
	}
	if (raisedEvent.name == 'system-addon-scene-responder.iterateSpecialDevices') {
		lInfo.logln('fetch for gtin ' + raisedEvent.parameter.gtin);
		var h = new HTTP({
			'debug' : 0
		}, {});
		var code = h.get("http://db.aizo.net/specialDevices.php?gtin=" + raisedEvent.parameter.gtin,null, function(code) {
			if (code.status.valueOf() === 200) {
				lInfo.logln(code.body);
				var DataObject = JSON.parse(code.body);
				if (DataObject.answer != 'nospecial') {
					if (Property.getNode('specialDevices')!=null)
						Property.getNode('specialDevices').removeChild(raisedEvent.parameter.gtin);

					if (DataObject.actions != null) {
						if (DataObject.actions['zone-action'] != null) {
							for (var iIndex = 0; iIndex < DataObject.actions['zone-action'].length; iIndex++) {
								var oDataObject = DataObject.actions['zone-action'][iIndex];
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/zoneAction/' + iIndex + '/name/' + sKey, oDataObject.name[sKey]);
								}

								Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/zoneAction/' + iIndex + '/scene', oDataObject.scene);
								if (oDataObject.zone != null)
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/zoneAction/' + iIndex + '/zone', oDataObject.zone);
								if (oDataObject.group != null)
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/zoneAction/' + iIndex + '/group', oDataObject.group);
							}
						}
						if (DataObject.actions['device-action'] != null) {
							for (var iIndex = 0; iIndex < DataObject.actions['device-action'].length; iIndex++) {
								var oDataObject = DataObject.actions['device-action'][iIndex];
								lInfo.logln('action ' + JSON.stringify(oDataObject));
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/deviceActions/' + iIndex + '/name/' + sKey, oDataObject.name[sKey]);
								}
								if (oDataObject.scene != null)
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/deviceActions/' + iIndex + '/scene', oDataObject.scene);
								if (oDataObject.outputValue != null)
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/actions/deviceActions/' + iIndex + '/outputValue', oDataObject.outputValue);
							}
						}
					}
					if (DataObject.triggers != null) {
						if (DataObject.triggers['zone-scene'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['zone-scene'].length; iIndex++) {
								var oDataObject = DataObject.triggers['zone-scene'][iIndex];
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/zoneSzene/' + iIndex + '/name/' + sKey, oDataObject.name[sKey]);
								}
								Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/zoneSzene/' + iIndex + '/scene', oDataObject.scene);
								if (oDataObject.zone != null)
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/zoneSzene/' + iIndex + '/zone', oDataObject.zone);
								if (oDataObject.group != null)
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/zoneSzene/' + iIndex + '/group', oDataObject.group);
							}
						}
						if (DataObject.triggers['device'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['device'].length; iIndex++) {
								var oDataObject = DataObject.triggers['device'][iIndex];
								Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/deviceMsg/' + iIndex + '/id', oDataObject.id);
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/deviceMsg/' + iIndex + '/name/' + sKey, oDataObject.name[sKey]);
								}
							}
						}
						if (DataObject.triggers['sensor-event'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['sensor-event'].length; iIndex++) {
								var oDataObject = DataObject.triggers['sensor-event'][iIndex];
								Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/sensorEvent/' + iIndex + '/id', oDataObject.id);
								Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/sensorEvent/' + iIndex + '/value', oDataObject.value);
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/sensorEvent/' + iIndex + '/name/' + sKey, oDataObject.name[sKey]);
								}
							}
						}
						if (DataObject.triggers['device-event'] != null) {
							for (var iIndex = 0; iIndex < DataObject.triggers['device-event'].length; iIndex++) {
								var oDataObject = DataObject.triggers['device-event'][iIndex];
								Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/deviceEvents/' + iIndex + '/id', oDataObject.id);
								for ( var sKey in oDataObject.name) {
									Property.setSavedProperty('specialDevices/' + raisedEvent.parameter.gtin + '/triggers/deviceEvents/' + iIndex + '/name/' + sKey, oDataObject.name[sKey]);
								}
							}
						}
					}
					Property.store();
				}
			}
		});
	}

	if (raisedEvent.name == 'system-addon-scene-responder.fetchSpecialDevices') {
		if (raisedEvent.parameter.strategy != null) {
			lInfo.logln('fetch gtin nicely');
			if (Property.getNode('actionScheduled') == null) {
				lInfo.logln('no action scheduled -> +2 minute should be fetched');
				new Event('system-addon-scene-responder.fetchSpecialDevices', {
					'time' : '+120'
				}).raise();
			} else
				lInfo.logln('action scheduled, so no new action');
			Property.setProperty('actionScheduled', true);
		} else {
			if (Property.getNode('actionScheduled') != null)
				Property.getNode('/scripts/system-addon-scene-responder').removeChild('actionScheduled');
			var oGTIN = {};
			var deviceArray = Property.getNode('/apartment/zones/zone0/devices').getChildren();
			for (var iIndex = 0; iIndex < deviceArray.length; iIndex++) {
				var oNode = deviceArray[iIndex];

				var GTIN = oNode.getChild('productInfo/EAN').getValue();
				if (GTIN != null)
					if (GTIN != "0") {
						oGTIN[GTIN] = 1;
					} else {
						//lInfo.logln('device ' + oNode.getChild('dSUID').getValue() + ' has no GTIN (function ' + oNode.getChild('functionID').getValue() + ')');
						//oGTIN["" + oNode.getChild('functionID').getValue()] = 1;
					}
			}
			for ( var sKey in oGTIN) {
				lInfo.logln('starting for gtin ' + sKey);
				new Event('system-addon-scene-responder.iterateSpecialDevices', {
					gtin : sKey
				}).raise();
			}
		}
	}
} catch (e) {
	lWarn.logln(e);
}
